#include "rc5_encoder.h"


void rc5_send(RC5_DATA * rc5)
{
  uint8_t n;
  uint8_t rc5_bit_count = RC5_BITS;
  rc5->start=3; 	// Startbits immer 1
  while (rc5_bit_count--)
  {
    if (rc5->code & 0x8000) 	// MSB prfen, 
    {							// 1 senden, Pause + moduliertes Signal
      _delay_us(RC5_BIT_TIME);
      for (n = RC5_CYCLES; n; n--)		// Halbbit wird an- und ausgeschaltet (moduliert)
      {
        RC5_SET(); 		
        _delay_us(13.89); 	// 889/32/2=13,89
        RC5_CLR(); 		
        _delay_us(13.89); 	// 889/32/2=13,89
      }
    }
    else // 0 senden, moduliertes Signal+Pause
    {
      for (n = RC5_CYCLES; n; n--)		// Halbbit wird an- und ausgeschaltet (moduliert)
      {
        RC5_SET(); 	
        _delay_us(13.89); 	// 889/32/2=13,89
        RC5_CLR(); 
        _delay_us(13.89); 	// 889/32/2=13,89
      }
      _delay_us(RC5_BIT_TIME);
    }
    rc5->code <<= 1;	// weitershiften fr nchstes Bit
  }
}
